# Python Example Package
[![Tests](https://github.com/letuanhai/python-example-package-lth/workflows/Tests/badge.svg)](https://github.com/letuanhai/python-example-package-lth/actions?workflow=Tests)
[![Codecov](https://codecov.io/gh/letuanhai/python-example-package-lth/branch/master/graph/badge.svg)](https://codecov.io/gh/letuanhai/python-example-package-lth)
[![PyPI](https://img.shields.io/pypi/v/hypermodern-python.svg)](https://pypi.org/project/letuanhai/python-example-package-lth/)

Clone of cjolowicz/hypermodern-python

Making an example package using *modern* Python toolchain.
To quick start with a [Cookiecutter](https://github.com/cookiecutter/cookiecutter) template, refer to [https://github.com/cjolowicz/cookiecutter-hypermodern-python](https://github.com/cjolowicz/cookiecutter-hypermodern-python).

Topics covered:
- Create a package in *src* layout
- Manage dependency with *Poetry*
- Command-line interfaces with *click*
- Consume a REST API with *requests*
- Unit testing with *pytest*
- Code coverage with *Coverage.py*
- Test automation with *Nox*
- Mocking with *pytest-mock*
- End-to-end testing
- Linting with *flake8*
- Code formatting with *black*
- Checking import with *flake8-import-order*
- Finding more bugs with *flake8-bugbear*
- Identifying security issues with *bandit*
- Finding security vulnerabilities in dependencies with *Safety*
- Managing dependencies in *Nox* sessions with *Poetry*
- Managing Git hooks with *pre-commit*
